/*
 * Created on Jun 20, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package net.daconta.webservices;

import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

/**
 * @author Michael C. Daconta
 *
 * A class which implements the ClassHierarchyService
 * and will be deployed as a web service that implements
 * the service defined in GoodClassHierarchy.wsdl
 */
public class ClassHierarchyServiceImpl
	implements ClassHierarchyServicePortType 
{
	Document dom;
	
	public ClassHierarchyServiceImpl() throws IOException
	{
		try
		{		
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = dbf.newDocumentBuilder();
			DOMImplementation dimpl = builder.getDOMImplementation();
			DocumentType dtype = dimpl.createDocumentType("RDF", null, "simple-rdf.xsd");
			dom = dimpl.createDocument("http://www.w3.org/1999/02/22-rdf-syntax-ns#","rdf:RDF", dtype);

		} catch (Exception e)
		  {
		  	throw new IOException(e.getMessage());
		  }
	}

	/* (non-Javadoc)
	 * @see net.daconta.webservices.ClassHierarchyServicePortType#getClassHierarchy(org.w3c.dom.Document)
	 */
	public Document getClassHierarchy(Document input) 
	{
		// temp - ignore input
		Element root = dom.getDocumentElement();
		root.setAttribute("xmlns:rdf","http://www.w3.org/1999/02/22-rdf-syntax-ns#");
		root.setAttribute("xmlns:rdfs","http://www.w3.org/2000/01/rdf-schema#");
		Element class1 = dom.createElement("rdfs:Class");
		root.appendChild(class1);
		class1.setAttribute("rdf:about","Anarchist");
		class1.setAttribute("rdfs:label","Anarchist");
		Element class2 = dom.createElement("rdfs:subClassOf");
		class2.setAttribute("rdf:resource", "#Radical");
		class1.appendChild(class2);
		
		Element class3 = dom.createElement("rdfs:Class");
		root.appendChild(class3);
		class3.setAttribute("rdf:about","Animal");
		class3.setAttribute("rdfs:label","Animal");
		Element class4 = dom.createElement("rdfs:subClassOf");
		class4.setAttribute("rdf:resource", "#Organism");
		class3.appendChild(class4);
		
		Element class5 = dom.createElement("rdfs:Class");
		root.appendChild(class5);
		class5.setAttribute("rdf:about","Creator");
		class5.setAttribute("rdfs:label","Creator");
		Element class6 = dom.createElement("rdfs:subClassOf");
		class6.setAttribute("rdf:resource", "#Person");
		class5.appendChild(class6);
		
		Element class7 = dom.createElement("rdfs:Class");
		root.appendChild(class7);
		class7.setAttribute("rdf:about","Debator");
		class7.setAttribute("rdfs:label","Debator");
		Element class8 = dom.createElement("rdfs:subClassOf");
		class8.setAttribute("rdf:resource", "#Disputant");
		class7.appendChild(class8);

		Element class9 = dom.createElement("rdfs:Class");
		root.appendChild(class9);
		class9.setAttribute("rdf:about","Disputant");
		class9.setAttribute("rdfs:label","Disputant");
		Element class10 = dom.createElement("rdfs:subClassOf");
		class10.setAttribute("rdf:resource", "#Person");
		class9.appendChild(class10);
		
		Element class11 = dom.createElement("rdfs:Class");
		root.appendChild(class11);
		class11.setAttribute("rdf:about","Organism");
		class11.setAttribute("rdfs:label","Organism");
				
		Element class14 = dom.createElement("rdfs:Class");
		root.appendChild(class14);
		class14.setAttribute("rdf:about","Plant");
		class14.setAttribute("rdfs:label","Plant");
		Element class15 = dom.createElement("rdfs:subClassOf");
		class15.setAttribute("rdf:resource", "#Organism");
		class14.appendChild(class15);
		
		Element class16 = dom.createElement("rdfs:Class");
		root.appendChild(class16);
		class16.setAttribute("rdf:about","Radical");
		class16.setAttribute("rdfs:label","Radical");
		Element class17 = dom.createElement("rdfs:subClassOf");
		class17.setAttribute("rdf:resource", "#Disputant");
		class16.appendChild(class17);		
		
		Element class18 = dom.createElement("rdfs:Class");
		root.appendChild(class18);
		class18.setAttribute("rdf:about","Reformer");
		class18.setAttribute("rdfs:label","Reformer");
		Element class19 = dom.createElement("rdfs:subClassOf");
		class19.setAttribute("rdf:resource", "#Disputant");
		class18.appendChild(class19);		
		
		Element class20 = dom.createElement("rdfs:Class");
		root.appendChild(class20);
		class20.setAttribute("rdf:about","Terrorist");
		class20.setAttribute("rdfs:label","Terrorist");
		Element class21 = dom.createElement("rdfs:subClassOf");
		class21.setAttribute("rdf:resource", "#Radical");
		class20.appendChild(class21);		

		Element class22 = dom.createElement("rdfs:Class");
		root.appendChild(class22);
		class22.setAttribute("rdf:about","Person");
		class22.setAttribute("rdfs:label","Person");
		Element class23 = dom.createElement("rdfs:subClassOf");
		class23.setAttribute("rdf:resource", "#Organism");
		class22.appendChild(class23);
		
		return dom;
	}

	/**
	 * For unit testing only.  Real deployment via a 
	 * web service.
	 * @param args
	 */
	public static void main(String [] args)
	{
		try
		{
			ClassHierarchyServicePortType service = new ClassHierarchyServiceImpl();
			Document dom = service.getClassHierarchy(null);
			TransformerFactory tff = TransformerFactory.newInstance();
			Transformer tf = tff.newTransformer();
			String systemValue = dom.getDoctype().getSystemId();
			tf.setOutputProperty(OutputKeys.DOCTYPE_SYSTEM,systemValue);			
			DOMSource ds = new DOMSource(dom.getDocumentElement());
			StreamResult sr = new StreamResult(System.out);
			tf.transform(ds,sr);
		} catch (Throwable t)
		  {
		  	t.printStackTrace();	
		  }
	}

}
